{# Group mappings into services by the same scheme+host+port #}
{%- set services = [] %}
{%- for mapping in rps_mappings %}
  {%- set scheme = mapping["source"] | urlsplit("scheme") %}
  {%- set is_tls = true if scheme == 'https' else false %}
  {%- set default_port = is_tls | ternary(443, 80) %}
  {%- set port = mapping["source"] | urlsplit("port") | default(default_port, true) %}
  {%- set host = mapping["source"] | urlsplit("hostname") %}
  {%- set service_id = "{}://{}:{}".format(scheme, host, port) | hash("md5") %}

  {%- set group_by = {"new_group": true} %}
  {%- for service in services %}
    {%- if service["id"] == service_id %}
      {%- set _ = service["mappings"].append(mapping) %}
      {%- set _ = group_by.update({"new_group": false}) %}
    {%- endif %}
  {%- endfor %}

  {%- if group_by["new_group"] %}
    {%- set _ = services.append({
      "id": service_id,
      "scheme": scheme,
      "host": host,
      "port": port,
      "is_tls": is_tls,
      "mappings": [mapping]
    }) %}
  {%- endif %}
{%- endfor %}

###############################################################################
### EXTRA PORTS DECLARATION
###############################################################################

{%- set ports = [] %}
{%- for service in services %}
  {%- if service["port"] != 80 and service["port"] != 443 and service["port"] not in ports %}
    {%- set _ = ports.append(service["port"]) %}
  {%- endif %}
{%- endfor %}

{%- for port in ports %}
Listen {{ port }}
{% endfor %}

###############################################################################
### SERVER: DEFAULT
###############################################################################

<VirtualHost *:80>
  ServerName _

  <IfModule status_module>
    <Location /snet/apache/status>
      SetHandler server-status
      Require ip 127
    </Location>
  </IfModule>

  <IfModule info_module>
    <Location /snet/apache/info>
      SetHandler server-info
      Require ip 127
    </Location>
  </IfModule>

  <Location /snet/agent>
    ProxyPass http://127.0.0.1:8000/
    ProxyPassReverse http://127.0.0.1:8000/

    {%- if restricted_allowed_origins %}
    Require all denied
      {%- for origin in restricted_allowed_origins %}
    Require ip {{ origin }}
      {%- endfor %}
    {%- endif %}
  </Location>
</VirtualHost>

{% for service in services %}
{% include "apache2-service.j2" %}
{% endfor %}
